//Conversion de dcimal vers BCD
UCHAR decimal_vers_bcd(UCHAR Valeur)
{
      return (((Valeur/10)<<4)+(Valeur%10));
}


//Conversion de BCD vers dcimal
double bcd_vers_decimal(UCHAR Valeur)
{
      return (((Valeur>>4)*10)+(Valeur%16));
}


// Initialisation de la liaison IC
BOOLEAN InitI2C(IOWKIT_HANDLE IOWarrior)
{
     IOWKIT_SPECIAL_REPORT rapport;
        
    memset(&rapport, 0, 8);
    rapport.ReportID = 0x01;
    rapport.Bytes[0] = 0x01;
    if (IowKitWrite(IOWarrior, 1, (char *) &rapport, 8)  == 8)
       return TRUE;
    else
       return FALSE;
}


// Fermeture de la  de la liaison IC
BOOLEAN CloseI2C(IOWKIT_HANDLE IOWarrior)
{
     IOWKIT_SPECIAL_REPORT rapport;
     
     memset(&rapport, 0, 8);
     rapport.ReportID = 0x01;
     rapport.Bytes[0] = 0x00;
     if(IowKitWrite(IOWarrior, 1, (char *) &rapport, 8) == 8)
         return TRUE;
     else
         return FALSE;
}

// Initialisation de la RTC
void InitRTC(IOWKIT_HANDLE IOWarrior, double *PInput)
{
    IOWKIT_SPECIAL_REPORT rapport;
   
    memset(&rapport, 0, 8);              // Mise  0 de rapport
    rapport.ReportID = 0x02;             //Opration criture
    rapport.Bytes[0] = 0x86;             //Start + 6 bytes
    rapport.Bytes[1] = 0xD0;             //Adresse + ecriture     
    rapport.Bytes[2] = 0x00;             //Adresse du 1er octet de la rtc
    rapport.Bytes[3] = decimal_vers_bcd((UCHAR)PInput[E_sec]);  //seconde
    rapport.Bytes[4] = decimal_vers_bcd((UCHAR)PInput[E_min]);  //minutes
    rapport.Bytes[5] = decimal_vers_bcd((UCHAR)PInput[E_heu]);  //heures
    rapport.Bytes[6] = 0x00;                                    //jour
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8);            //Ecriture
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);             //Lecture des erreurs        
    if (rapport.Bytes[0]>0x7F)                                  //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("InitialisationRTC"), MB_OK);
    memset(&rapport, 0, 8);                        // Mise  0 de rapport
    rapport.ReportID = 0x02;                       //Opration criture
    rapport.Bytes[0] = 0x43;                       //3 bytes + stop 
    rapport.Bytes[1] = decimal_vers_bcd((UCHAR)PInput[E_dat]);  //date
    rapport.Bytes[2] = decimal_vers_bcd((UCHAR)PInput[E_moi]);  //mois
    rapport.Bytes[3] = decimal_vers_bcd((UCHAR)PInput[E_ann]);  //anne
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8);                   //Ecriture
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);                    //Lecture des erreurs
    if (rapport.Bytes[0]>0x7F)                                         //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("InitialisationRTC"), MB_OK);
}

// Lecture de l'heure de la RTC
IOWKIT_SPECIAL_REPORT Lecture_heureRTC(IOWKIT_HANDLE IOWarrior)
{
     IOWKIT_SPECIAL_REPORT rapport;
        
     //initialisation du pointeur
     memset(&rapport, 0, 8);                     // Mise  0 de rapport
     rapport.ReportID = 0x02;                    //Fonction criture
     rapport.Bytes[0] = 0xc2;                    //Start + stop + 2 bytes
     rapport.Bytes[1] = 0xD0;                    //Adresse + ecriture
     rapport.Bytes[2] = 0x00;                    //Adresse du 1er octet de la rtc
     IowKitWrite(IOWarrior, 1, (char *) &rapport, 8); //Ecriture des donnes
     IowKitRead(IOWarrior, 1, (char *) &rapport, 8);  //Lecture des erreurs
     if (rapport.Bytes[0]>0x7F)                       //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("Leture"), MB_OK);
       
     //demande de lecture des 3 octets
     memset(&rapport, 0, 8);                     // Mise  0 de rapport
     rapport.ReportID = 0x03;                    //Opration lecture
     rapport.Bytes[0] = 0x03;                    //nombre d'octets  lire
     rapport.Bytes[1] = 0xD1;                    //Adresse + lecture
     IowKitWrite(IOWarrior, 1, (char *) &rapport, 8); //Ecriture des donnes
     IowKitRead(IOWarrior, 1, (char *) &rapport, 8);  //Lecture des erreurs et donnes

     return rapport;                                  //Retourner les donnes lues
}


// Lecture de la date de la RTC
IOWKIT_SPECIAL_REPORT Lecture_dateRTC(IOWKIT_HANDLE IOWarrior)
{
    IOWKIT_SPECIAL_REPORT rapport;
       
    
    //initialisation du pointeur
    memset(&rapport, 0, 8);                    // Mise  0 de rapport
    rapport.ReportID = 0x02;                   //Fonction ecriture
    rapport.Bytes[0] = 0xc2;                   //Start + stop + 2 bytes
    rapport.Bytes[1] = 0xD0;                   //Adresse + ecriture
    rapport.Bytes[2] = 0x04;                   //Adresse du 1er octet de la date de la rtc
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8); //Ecriture des donnes
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);  //Lecture des erreurs
    if (rapport.Bytes[0]>0x7F)                       //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("Leture"), MB_OK);
    
    //demande de lecture des 4 octets
    memset(&rapport, 0, 8);                   // Mise  0 de rapport
    rapport.ReportID = 0x03;                  //Fonction lecture
    rapport.Bytes[0] = 0x03;                  //nombre d'octets  lire
    rapport.Bytes[1] = 0xD1;                  //Adresse + lecture
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8); //Ecriture des commandes
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);  //Lecture des erreurs et donnes
    
    return rapport;                                  //Retourner les donnes lues
}
